/**************************************************************************   
 *                                                                        *
 *    File Name : remove_comments.h                                       *
 *                                                                        *
 *    Author    : KIM, DONGMIN (kimd@top.cis.syr.edu)                     *
 *                                                                        *
 *    Function  : This file read the C or C++ file and copies it          *
 *                except the comments.                                    *
 *                                                                        *
 **************************************************************************/

#include <stdio.h>

# ifndef REMOVE_COMMENTS_H
/**************************************************************************   
 *                                                                        *
 *       The constants                                                    *
 *                                                                        *
 **************************************************************************/
#define Star   42
#define Slash  47
#define Return 10

/**************************************************************************   
 *                                                                        *
 *      PROCEDURE       : check_comments()                                *
 *      INPUT           : none                                            *
 *      FUNCTION        : Check to see that the comments are exists.      *
 *                                                                        *
 **************************************************************************/
check_comments(FILE *input, FILE *output) {

  int     ch, prev_ch;

  ch = fgetc(input);
  if ( ch == Slash ) { /* case : // */
    while (1) {
      ch = fgetc(input);
      if ( ch == Return ) {
	put_2_output(output, ch);
	break;
      }
    }
  }

  else if ( ch == Star ) { /* case : */ /* & */
    ch = fgetc(input);
    while (1) {
      prev_ch = ch;
      ch = fgetc(input);
      if ( prev_ch == Star && ch == Slash ) break;
    }
  }

  else {
    ch = Slash;
    put_2_output(output, ch);
  }

}

/**************************************************************************   
 *                                                                        *
 *      PROCEDURE       : put_2_output()                                  *
 *      INPUT           : FILE, int                                       *
 *      FUNCTION        : Put the input charactor into output file.       *
 *                                                                        *
 **************************************************************************/
put_2_output(FILE *output, int ch) {

/*  printf("charactor = %c = %X = %d\n", ch, ch, ch); */

  fputc(ch, output);


}

/**************************************************************************   
 *                                                                        *
 *      PROCEDURE       : remove_comments()                               *
 *      INPUT           : FILE, FILE                                      *
 *      FUNCTION        : remove the comments from the input file, and    *
 *                        make output file for no comments file.          *
 *                                                                        *
 **************************************************************************/
remove_comments(FILE *input, FILE *output) {

  int     ch;

/* read the input file until EOF */
  while (1) {
    ch = fgetc(input);
    if ( ch == EOF ) break;

    if ( ch == Slash )
      check_comments(input, output);
    else {
/*      printf("%c = %X = %d\n", ch, ch, ch); */
      put_2_output(output, ch);
    }

  }

}

# endif
